/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.benutzerverwaltung.boundary;

import javax.persistence.NoResultException;
import javax.persistence.NonUniqueResultException;
import javax.persistence.EntityNotFoundException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import de.ivu.elect.business.benutzerverwaltung.entity.Nachricht;
import de.ivu.elect.business.benutzerverwaltung.entity.NachrichtUK;

public abstract class AbstractNachrichtDAO extends de.ivu.elect.jee.entity.AbstractDAO<Nachricht,
        de.ivu.elect.business.benutzerverwaltung.entity.NachrichtPK
    , NachrichtUK> {

  private static final long serialVersionUID = 1L;

  private static final Logger LOG = LoggerFactory.getLogger(AbstractNachrichtDAO.class);

  public AbstractNachrichtDAO() {
    super();
  }

  public boolean isEntityWithPKPresent(
            de.ivu.elect.business.benutzerverwaltung.entity.NachrichtPK
     pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk) != null;
    }

    return false;
  }

  @Override
  public Nachricht findByPrimaryKey(
        de.ivu.elect.business.benutzerverwaltung.entity.NachrichtPK
      pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk.getId());
    }

    throw new IllegalArgumentException("PK oder PK.getId() ist null! [pk = " + pk + "]");
  }


  @Override
  protected Nachricht findByPrimaryKey(Long id) {
    if (id == null) {
      throw new IllegalArgumentException("ID ist null! [id = " + id + "]");
    }
  return getEntityManager().find(Nachricht.class, id, CACHE_PROPERTIES);
  }



     /**
      * Name: AllNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Nachricht o WHERE o.mandant=?1<br>
      * SQL: <br>
      */
     public java.util.List<Nachricht> findByAll( @javax.annotation.Nonnull de.ivu.elect.business.mandant.entity.Mandant mandant) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.mandant.entity.Mandant mandantCheckedAndAttached =  checkAndAttach(mandant, de.ivu.elect.business.mandant.entity.Mandant.class, "mandant"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("NACHRICHT.All")
                              .setParameter(1, mandantCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("Nachricht, findByAll - NonUniqueResultException, Parameter: "
           + ", mandant:'"+mandant+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByAll(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: CountByUngelesenNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT COUNT(nachricht) FROM Nachricht nachricht LEFT JOIN nachricht.rolles nachrichtRolle WHERE nachricht.mandant=?4 AND ((nachricht.senderkennung <> ?1) AND (nachricht.id > ?2) AND (nachricht.empfaengerGruppeArt = 'ALLE' OR nachrichtRolle.id IN (?3) OR EXISTS(SELECT urspruenglicheNachricht FROM Nachricht urspruenglicheNachricht LEFT JOIN urspruenglicheNachricht.rolles urspruenglicheNachrichtRolle WHERE (urspruenglicheNachricht.id = nachricht.urspruenglicheNachricht.id) AND (urspruenglicheNachricht.senderkennung = ?1 OR urspruenglicheNachricht.empfaengerGruppeArt = 'ALLE' OR urspruenglicheNachrichtRolle.id IN (?3)))))<br>
      * SQL: <br>
      */
     public java.lang.Long findByCountByUngelesen( @javax.annotation.Nonnull java.lang.String senderkennung,  @javax.annotation.Nonnull java.lang.Long letzteId,  @javax.annotation.Nonnull java.util.Collection<java.lang.Long> empfaengerRolleIds,  @javax.annotation.Nonnull de.ivu.elect.business.mandant.entity.Mandant mandant) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  java.lang.String senderkennungCheckedAndAttached =  senderkennung ;
		  			  java.lang.Long letzteIdCheckedAndAttached =  letzteId ;
		  			  java.util.Collection<java.lang.Long> empfaengerRolleIdsCheckedAndAttached =  empfaengerRolleIds ;
		  			  de.ivu.elect.business.mandant.entity.Mandant mandantCheckedAndAttached =  checkAndAttach(mandant, de.ivu.elect.business.mandant.entity.Mandant.class, "mandant"); ;
		  
                              return
                    (java.lang.Long)
                              getEntityManager().
                                createNamedQuery("NACHRICHT.CountByUngelesen")
                              .setParameter(1, senderkennungCheckedAndAttached)
                                        .setParameter(2, letzteIdCheckedAndAttached)
                                        .setParameter(3, empfaengerRolleIdsCheckedAndAttached)
                                        .setParameter(4, mandantCheckedAndAttached)
                                                                      .getSingleResult();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByCountByUngelesen - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Nachricht, findByCountByUngelesen - NonUniqueResultException, Parameter: "
           + ", senderkennung:'"+senderkennung+"'"
           + ", letzteId:'"+letzteId+"'"
           + ", empfaengerRolleIds:'"+empfaengerRolleIds+"'"
           + ", mandant:'"+mandant+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByCountByUngelesen(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }



  @Override
  public boolean isEntityWithUKPresent(de.ivu.elect.business.benutzerverwaltung.entity.NachrichtUK uk) {
    try {
      return findByUK(uk) != null;
    } catch (javax.persistence.NoResultException nre) {
      return false;
    }
  }

  @Override
  public boolean isEntityWithUKHasPK(de.ivu.elect.business.benutzerverwaltung.entity.NachrichtUK uk,
        de.ivu.elect.business.benutzerverwaltung.entity.NachrichtPK
      pk

  ) {
    try {
      return findByUK(uk).getPk().equals(pk);
    } catch (NoResultException ignored) {
      // Do nothing - be happy.
    }
    return true;
  }

   public de.ivu.elect.business.benutzerverwaltung.entity.Nachricht findByUK(de.ivu.elect.business.benutzerverwaltung.entity.NachrichtUK uk){

    try {
     return (de.ivu.elect.business.benutzerverwaltung.entity.Nachricht) getEntityManager().createNamedQuery("NACHRICHT.UK")
                  .setParameter(1, uk
                .getMandantUK ()

                .getNummer ()

              )
          .getSingleResult()
     ;
     } catch (NonUniqueResultException nure) {
        LOG.warn("Nachricht, findByUK - NonUniqueResultException, UK: " + uk);
        throw nure;
     }
  }
    
}